---
title: "The story of t-env: Scaling a platform to impriove the volocity of hundreds of developers"
weight: 11
tags:
 - platform
 - cloudnativecon
---

<!-- {{% button href="https://youtu.be/rkteV6Mzjfs" style="warning" icon="video" %}}Watch talk on YouTube{{% /button %}} -->
<!-- {{% button href="https://docs.google.com/presentation/d/1nEK0CVC_yQgIDqwsdh-PRihB6dc9RyT-" style="tip" icon="person-chalkboard" %}}Slides{{% /button %}} -->

Okteto: Ephemeral environents for testing

## History

- Starting point: Local Dev -> Setup for new devices or devs is realy slow (on average 10hrs a week)
- Next Idea: EC2 Instances with a fancy docker-compose and scripts -> No more local dev
- Problems: Still complex -  just in the cloud, manual updates, allways-on required (no working in the train)
- Risks: Developers will just create workarounds and shadow it

## T-Env

- Baseline: Setup an environment on kubernetes for each dev with ci/cd
- Okteto: A single command to enter dev mode `t dev start` with file sync from local
- Implementation: Wrapper arount the okteto cli
- Why: Becaus dev seems to love the cli
- Self service observability for troubleshooting in your env

Used Open soruce Tools: Pulumi, Grafana, Okteto, K8s

### Did it work?

- The time to test is way faster
- The path was clear
- The environments should be ephemeral but devs don't like that -> They decided to allow for long lived envs
- Cloud cost is relatively high with long living envs -> They implemented a sleep system based on dev timezone 
(or manual wake-up)

## The futuuuuure

- The company is not getting smaller -> More devs annd more services
- AI agents will write some of the code in the future
- Idea: Only run modified code in env instead of everything